import java.net.*;
import java.io.*;

public class Httpd {
    public Httpd( ) {
        try {
            ServerSocket serverSocket = new ServerSocket(80);
            while (true) {
                Service service = new Service(serverSocket.accept( ));
                service.start( );
            }
        } catch(Exception e) {
            System.out.println(e);
        }
    }

    public static void main(String[] args) {
        new Httpd( );
    }
}

class Service extends Thread {
    private Socket socket;
    private BufferedReader from;
    private BufferedWriter to;

    public Service(Socket socket) {
        this.socket = socket;
        try {
            from = new BufferedReader(
                new InputStreamReader(socket.getInputStream( )));
            to = new BufferedWriter(
                new OutputStreamWriter(socket.getOutputStream( )));
        } catch (Exception e) {
            System.out.println(e);
        }
    }

    public void run( ) {
        try {
            String string;
            do {
                if ((string = from.readLine( )) != null) {
                    System.out.println(string);
                    if (string.equals(""))
                        string = null;
                }
            } while (string != null);
            to.write("HTTP/1.1 401 Authorization Required\r\n");
            to.write("WWW-Authenticate: Digest realm=\"KO-HI-\", " +
                "nonce=\"rkbsOg==0a37505fde31a16911eab4c2f7dc" +
                "7ab44723fa5e\", " +
                "algorithm=MD5, " +
                "domain=\"/usr/local/apache/htdocs/KO-HI-/\", " +
                "qop=\"auth\"\r\n\r\n");
            to.write("test\r\n");
            to.flush( );
            socket.close( );
        } catch(Exception e) {
            System.out.println(e);
        }
    }
}